<?php
defined('_JEXEC') or die('Direct Access to this location is not allowed.');
require_once(dirname(__FILE__).DS.'helper.php');
$template = $params->get('template');

if ($template!=-1){
	$name         		= strtolower(array_shift(explode(".", $template)));
	$ft     				= file_get_contents(JPATH_SITE."/modules/mod_grabber/templates/".$template);
	$module_id 		= ModGrabberHelper::tmpl_parser('module_id', $ft);
	$url 					= ModGrabberHelper::tmpl_parser('url', $ft);
	$start 				= ModGrabberHelper::tmpl_parser('start_tag', $ft);
	$end 					= ModGrabberHelper::tmpl_parser('end_tag', $ft);
	$show 				= ModGrabberHelper::tmpl_parser('show_tags', $ft);
	$starttext 			= ModGrabberHelper::tmpl_parser('starttext', $ft);
	$endtext 			= ModGrabberHelper::tmpl_parser('endtext', $ft);
	$usecache 			= ModGrabberHelper::tmpl_parser('usecache', $ft);
	$fromcharset 		= ModGrabberHelper::tmpl_parser('fromcharset', $ft);
	$tocharset			= ModGrabberHelper::tmpl_parser('tocharset', $ft);
	$replace_params	= ModGrabberHelper::tmpl_parser('replace_params', $ft);
	$regexp 				= ModGrabberHelper::tmpl_parser('regexp', $ft);
	$regexp 				= str_replace('$start', $start, $regexp);
	$regexp 				= str_replace('$end', $end, $regexp);
	$mestype 	    	= ModGrabberHelper::tmpl_parser('mestype', $ft);
}else{
	$module_id			= $params->get('module_id');
	$url          			= $params->get('url');
	$start        		= $params->get('start_tag');
	$end          		= $params->get('end_tag');
	$show         		= $params->get('show_tags');
	$starttext    		= $params->get('starttext');
	$endtext      		= $params->get('endtext');
	$usecache     		= $params->get('usecache');
	$fromcharset  		= $params->get('fromcharset');
	$tocharset    		= $params->get('tocharset');
	$replace_params	= $params->get('replace_params');
	$regexp 	  			= $params->get('regexp','#$start(.*?)$end#s');
	$regexp 	  			= str_replace('$start', $start, $regexp);
	$regexp 	  			= str_replace('$end', $end, $regexp);
	$mestype 	 		= $params->get('mestype');
}

if (!$usecache) {
	$html = $starttext.ModGrabberHelper::grabhtml($url, $start, $end, $show, $regexp, $mestype).$endtext;
	if (($fromcharset<>'') AND ($tocharset<>'')) $html = ModGrabberHelper::correct_charset($fromcharset, $tocharset, $html);
	if ($replace_params) $html = ModGrabberHelper::replaceit($replace_params, $html);
} 

if ($usecache) {
	if ($template!=-1){
		if ((!file_exists(JPATH_SITE.'/modules/mod_grabber/content/'.$name.DS.$name.'.html'))) {
			mkdir(JPATH_SITE."/modules/mod_grabber/content/$name", 0755);
			$handle = fopen(JPATH_SITE.'/modules/mod_grabber/content/'.$name.DS.$name.'.html', 'a+');
			fclose($handle); 			
		}
		$tmpfname = JPATH_SITE.'/modules/mod_grabber/content/'.$name.DS.$name.'.html';
	}else{
		if ((!file_exists(JPATH_SITE.'/modules/mod_grabber/content/mod_grabber_'.$module_id.'.html'))) {
			$handle = fopen(JPATH_SITE.'/modules/mod_grabber/content/mod_grabber_'.$module_id.'.html', 'a+');
			fclose($handle); 			
		}
		$tmpfname = JPATH_SITE.'/modules/mod_grabber/content/mod_grabber_'.$module_id.'.html'; 
	}
	
	if (((filemtime($tmpfname)) < (time()-$usecache*3600)) OR (filesize($tmpfname)==0)){
		$html = $starttext.ModGrabberHelper::grabhtml($url, $start, $end, $show, $regexp, $mestype).$endtext;
		if (($fromcharset<>'') AND ($tocharset<>'')) $html = ModGrabberHelper::correct_charset($fromcharset, $tocharset, $html);
		if ($replace_params) $html = ModGrabberHelper::replaceit($replace_params, $html);
		ModGrabberHelper::create_cache_file($tmpfname, $html );
	}else{
		$html = file_get_contents($tmpfname);
	} 
}

require(JModuleHelper::getLayoutPath('mod_grabber'));
?>